#include "pcm.hh"

#include <sys/soundcard.h>
#include <sys/ioctl.h>

#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

PCM::PCM() : rate(44100), fd(-1)
{
	fd = open("/dev/dsp", O_WRONLY);
	if(fd >= 0)
	{
		rate = 22050;
		
		unsigned bits = 16;
		
		ioctl(fd, SNDCTL_DSP_SPEED, &rate);
		ioctl(fd, SNDCTL_DSP_SAMPLESIZE, &bits);
	}
	bufpos = 0;
}

PCM::~PCM()
{
	if(fd >= 0)close(fd);
}

unsigned PCM::getrate() const
{
	return rate;
}

void PCM::output(double value)
{
	if(fd >= 0)
	{
		int v = static_cast<int> (10000.0 * value);
		
		if(v < -32768)v = -32768;
		if(v > 32767)v = 32767;
		
		short c = v;
		
		Buf[bufpos++] = c;
		
		unsigned buflen = (sizeof Buf) / sizeof(Buf[0]);
		
		if(bufpos == buflen)
		{
			write(fd, &Buf, sizeof Buf);
			bufpos = 0;
		}
	}
}
